[libcamera-devel,v2] utils: hooks: Add pre-push commit hook

Message ID 20200326134821.8542-1-laurent.pinchart@ideasonboard.com
State Accepted
Commit 36ad4eb188e078c9ec577213872febae57185646
Headers show
Series
  • [libcamera-devel,v2] utils: hooks: Add pre-push commit hook
Related show

Commit Message

Laurent Pinchart March 26, 2020, 1:48 p.m. UTC
Add a pre-push commit hooks to prevent unintentional push of patches
containing local changelogs to the master branch.

Signed-off-by: Laurent Pinchart <laurent.pinchart@ideasonboard.com>
---
Changes since v1:

- Fix shellcheck issues
- Rewrite the description in the top comment
- Remove dead or useless code
---
 utils/hooks/pre-push | 43 +++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 43 insertions(+)
 create mode 100755 utils/hooks/pre-push

Comments

Niklas Söderlund April 14, 2020, 10:02 p.m. UTC | #1
Hi Laurent,

Thanks for your work.

On 2020-03-26 15:48:21 +0200, Laurent Pinchart wrote:
> Add a pre-push commit hooks to prevent unintentional push of patches
> containing local changelogs to the master branch.
> 
> Signed-off-by: Laurent Pinchart <laurent.pinchart@ideasonboard.com>

Finally found to test this patch, nice work it will relive some anxiety 
when I try to improve my workflow by writing more changelogs.

Reviewed-by: Niklas Söderlund <niklas.soderlund@ragnatech.se>

> ---
> Changes since v1:
> 
> - Fix shellcheck issues
> - Rewrite the description in the top comment
> - Remove dead or useless code
> ---
>  utils/hooks/pre-push | 43 +++++++++++++++++++++++++++++++++++++++++++
>  1 file changed, 43 insertions(+)
>  create mode 100755 utils/hooks/pre-push
> 
> diff --git a/utils/hooks/pre-push b/utils/hooks/pre-push
> new file mode 100755
> index 000000000000..099441b82ea6
> --- /dev/null
> +++ b/utils/hooks/pre-push
> @@ -0,0 +1,43 @@
> +#!/bin/sh
> +
> +# A hook script to prevent pushing unsuitable commits to the master branch.
> +# Unsuitable commits are commits that contain a local changelog below a '---'
> +# line. The criteria may get extended later.
> +#
> +# Information about the commits which are being pushed is supplied as lines to
> +# the standard input in the form:
> +#
> +#   <local ref> <local sha1> <remote ref> <remote sha1>
> +
> +z40=0000000000000000000000000000000000000000
> +
> +while read -r local_ref local_sha remote_ref remote_sha
> +do
> +	if [ "$remote_ref" != refs/heads/master ]
> +	then
> +		continue
> +	fi
> +
> +	# The remote master branch should never get deleted by this push, so we
> +	# can assume that local_sha is not 0's. We may however be creating the
> +	# remote branch, when pushing to a new empty repository for instance.
> +	if [ "$remote_sha" = $z40 ]
> +	then
> +		# New branch, examine all commits
> +		range="$local_sha"
> +	else
> +		# Update to existing branch, examine new commits
> +		range="$remote_sha..$local_sha"
> +	fi
> +
> +	# Find invalid commits.
> +	commit=$(git rev-list -n 1 --grep '^---' "$range")
> +	if [ -n "$commit" ]
> +	then
> +		echo >&2 "Found local changelog in $local_ref, not pushing"
> +		echo >&2 "Check commit $commit"
> +		exit 1
> +	fi
> +done
> +
> +exit 0
> -- 
> Regards,
> 
> Laurent Pinchart
> 
> _______________________________________________
> libcamera-devel mailing list
> libcamera-devel@lists.libcamera.org
> https://lists.libcamera.org/listinfo/libcamera-devel

Patch

diff --git a/utils/hooks/pre-push b/utils/hooks/pre-push
new file mode 100755
index 000000000000..099441b82ea6
--- /dev/null
+++ b/utils/hooks/pre-push
@@ -0,0 +1,43 @@ 
+#!/bin/sh
+
+# A hook script to prevent pushing unsuitable commits to the master branch.
+# Unsuitable commits are commits that contain a local changelog below a '---'
+# line. The criteria may get extended later.
+#
+# Information about the commits which are being pushed is supplied as lines to
+# the standard input in the form:
+#
+#   <local ref> <local sha1> <remote ref> <remote sha1>
+
+z40=0000000000000000000000000000000000000000
+
+while read -r local_ref local_sha remote_ref remote_sha
+do
+	if [ "$remote_ref" != refs/heads/master ]
+	then
+		continue
+	fi
+
+	# The remote master branch should never get deleted by this push, so we
+	# can assume that local_sha is not 0's. We may however be creating the
+	# remote branch, when pushing to a new empty repository for instance.
+	if [ "$remote_sha" = $z40 ]
+	then
+		# New branch, examine all commits
+		range="$local_sha"
+	else
+		# Update to existing branch, examine new commits
+		range="$remote_sha..$local_sha"
+	fi
+
+	# Find invalid commits.
+	commit=$(git rev-list -n 1 --grep '^---' "$range")
+	if [ -n "$commit" ]
+	then
+		echo >&2 "Found local changelog in $local_ref, not pushing"
+		echo >&2 "Check commit $commit"
+		exit 1
+	fi
+done
+
+exit 0